## zst 0.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.19)
	cmake_policy(SET CMP0110 NEW)
endif()
project(zst C)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckFunctionExists)
include(GNUInstallDirs)

if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "RelWithDebInfo")
endif (NOT CMAKE_BUILD_TYPE)

function(find_lib define so func)
	CHECK_LIBRARY_EXISTS(${so} ${func} "" HAVE_LIB${define})
	if(${HAVE_LIB${define}})
		set(libs ${libs} ${so} PARENT_SCOPE)
	endif()
endfunction()
find_lib(Z z gzread)
find_lib(BZ2 bz2 BZ2_bzBuffToBuffCompress)
find_lib(LZMA lzma lzma_code)
find_lib(ZSTD zstd ZSTD_compress)
CHECK_FUNCTION_EXISTS(copy_file_range HAVE_COPY_FILE_RANGE)
CHECK_FUNCTION_EXISTS(stat64 HAVE_STAT64)

function(add_flag flag)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${flag}" PARENT_SCOPE)
endfunction()
add_flag(-Wall)
add_flag(-Werror=format-security)
add_flag(-Wmissing-declarations)
add_flag(-Wredundant-decls)
add_flag(-Wno-parentheses)

configure_file(config.h.cmake ${CMAKE_BINARY_DIR}/config.h)
include_directories(${CMAKE_BINARY_DIR})

set(zst_sources
	compress.c
	zst.c
)

add_executable(zst ${zst_sources})
target_link_libraries(zst ${libs})

install(TARGETS zst DESTINATION bin)
install(FILES zst.1 zst.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
install(FILES ${CMAKE_BINARY_DIR}/zst DESTINATION bin)

enable_testing()
add_subdirectory(tests)

=== tests/CMakeLists.txt ===
file(GLOB tests
	LIST_DIRECTORIES false
	CONFIGURE_DEPENDS
	${CMAKE_CURRENT_SOURCE_DIR}/*.t)

function(compressor TOOL EXT)
	foreach(t ${tests})
		string(REGEX REPLACE ".*/([^/]*)\\.t$"
			"\\1" t
			${t})
		set(tn "${t}-${TOOL}")
		if(CMAKE_VERSION VERSION_LESS 3.19)
			string(REPLACE " " "_" tn "${tn}")
			string(REPLACE "#" "♯" tn "${tn}")
			string(REPLACE "(" "⦅" tn "${tn}")
			string(REPLACE ")" "⦆" tn "${tn}")
		endif()
		add_test(NAME ${tn}
			COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/runtest.sh "${t}")
		set_tests_properties(${tn} PROPERTIES
			SKIP_RETURN_CODE 42
			ENVIRONMENT "TOOL=${TOOL};EXT=${EXT};SRC=${CMAKE_SOURCE_DIR};BIN=${CMAKE_BINARY_DIR}")
	endforeach()
endfunction()

if(HAVE_LIBZ)
	compressor(gzip .gz)
endif()
if(HAVE_LIBBZ2)
	compressor(bzip2 .bz2)
endif()
if(HAVE_LIBLZMA)
	compressor(xz .xz)
endif()
if(HAVE_LIBZSTD)
	compressor(zstd .zst)
endif()

file(GLOB Tests
	LIST_DIRECTORIES false
	CONFIGURE_DEPENDS
	${CMAKE_CURRENT_SOURCE_DIR}/*.T)

foreach(t ${Tests})
	string(REGEX REPLACE ".*/([^/]*)\\.T$"
		"\\1" t
		${t})
	set(tn ${t})
	if(CMAKE_VERSION VERSION_LESS 3.19)
		string(REPLACE " " "_" tn "${tn}")
		string(REPLACE "#" "♯" tn "${tn}")
		string(REPLACE "(" "⦅" tn "${tn}")
		string(REPLACE ")" "⦆" tn "${tn}")
	endif()
	add_test(NAME ${tn}
		COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/runtest.sh "${t}")
	set_tests_properties(${tn} PROPERTIES
		SKIP_RETURN_CODE 42
		ENVIRONMENT "SRC=${CMAKE_SOURCE_DIR};BIN=${CMAKE_BINARY_DIR}")
endforeach()

## zst 0.2

=== debian/changelog ===
zst (0.2-1) unstable; urgency=medium

  * New upstream release, mostly portability changes.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 11 Jan 2023 09:01:17 +0100

zst (0.1-1) experimental; urgency=medium

  * Initial release (Closes: #1023305)

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 06 Dec 2022 11:46:16 +0100

=== debian/control ===
Source: zst
Section: utils
Priority: optional
Maintainer: Adam Borowski <kilobyte@angband.pl>
Build-Depends: debhelper-compat (= 13),
 cmake,
 libbz2-dev,
 liblzma-dev,
 libz-dev,
 libzstd-dev,
 bzip2,
 xz-utils,
 zstd,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/kilobyte/zst
Vcs-Browser: https://github.com/kilobyte/zst/tree/debian
Vcs-Git: https://github.com/kilobyte/zst -b debian

Package: zst
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: CLI tool for zstd (and other) compression
 This is an alternate tool for zstd compression, one that takes a lot
 less space than the official one.  It also behaves in a way consistent
 with other Unix compressors: the level goes only up to 9, the original
 copy of the file is not kept, etc.
 .
 The executable can also replace gzip xz bzip2.

## zst 0.4

=== debian/changelog ===
zst (0.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream fix for FTBFS with CMake 4. (Closes: #1113661)

 -- Adrian Bunk <bunk@debian.org>  Sat, 11 Oct 2025 13:29:24 +0300

zst (0.4-1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 08 Apr 2023 18:12:10 +0200

zst (0.3-1) unstable; urgency=medium

  * New upstream bugfix release.
  * Impose a minimal version of libzstd B-Dependency.
  * An autopkgtest.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 09 Mar 2023 08:52:52 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  libbz2-dev,
  liblzma-dev,
  libz-dev,
- libzstd-dev,
+ libzstd-dev (>> 1.4~),
  bzip2,
  xz-utils,
  zstd,

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall

%:
	dh $@

=== debian/tests/control ===
Tests: canned
